// TXTSRVR  This interface is copyright (c) by methodica herger & krasznai
//          Address:   Fellstr. 3, P.O. Box 39, CH-5413 Switzerland
//          Internet:  http://www.methodica.ch, mail@methodica.ch
//
//          This is the abstract text server class. Text servers are used
//          by the TICKER.CLASS applet to provide ASCII text to display line
//          by line.
//
//          If you wish to write your own specific text server for the
//          TICKER applet, you best proceed as follows:
//          1. copy the DEFTEXT.CLASS file and save it under a new name;
//          2. replace the class and constructor name matching the file
//             name you choose;
//          3. add your specific code to the methods;
//          4. compile.
//          5. copy into the same directory where you saved TICKER.CLASS.
//
//          To activate a server (DEFTEXT and FILDTXT are automatically
//          activated by TICKER), add an entry to your HTML code in the form:
//              <PARAM NAME="TextServer" VALUE="xxxxxxxx.class">
//          where xxxxxxxx is your class' name.
//
//          This code is freeware.
//          You are free to use and modify it, as long as due credit is
//          given, and the resulting source code is made available to the
//          public too.
//          If you use this code, drop us a line ("mail@Tmethodica.ch"), so
//          that we know, how many people are using it, and what an impact
//          modifications to it will have.
//
//          The code is given to the public domain on an "as is" basis.
//          This means, that neither the author, nor methodica can be made
//          responsible under any circumstances for damages caused by this
//          applet or malfunctions of this applet. Since the source codue
//          is published, you might convince yourself of the fact, that the
//          applet contains no offending or destructive code.
//
//          1998-06-09, Hans E. Herger <hans.herger@methodica.ch>

import java.net.URL;
import java.util.Hashtable;


public abstract class txtsrvr
{

    Hashtable ParameterList = null;

    // Standard constructor.
    //--------------------------------------------------------------------------
    public abstract void txtsrvr();

    // Initializes the class. Returns "true" if successful.
    //--------------------------------------------------------------------------
	public abstract boolean initText(URL uParam, String sParam, long lParam, int iParam);

    // Exits the class. Returns "true" if successful.
    //--------------------------------------------------------------------------
	public abstract void exitText();

    // Returns the text to be displayed.
    //--------------------------------------------------------------------------
    public abstract String getText();


    // Set a parameter.
    //--------------------------------------------------------------------------
    public String putParameter(String key, String value)
    {
        if (ParameterList == null) { ParameterList = new Hashtable(); }
    String s = (String)ParameterList.put(key.toUpperCase(), value);
    return s;

//        return  (ParameterList != null) ?
//                (String)ParameterList.put(key, value) :
//                null;
    }

    // Returns the text to be displayed.
    //--------------------------------------------------------------------------
    public String getParameter(String key)
    {
        if (ParameterList == null) return "";
        String v = (String)ParameterList.get(key.toUpperCase());
        return (v!=null) ? v : "";
    }
}
